//+------------------------------------------------------------------+
//|                                                     Trigger Line |
//|                             Copyright  2005 dwt5 and adoleh2000 |
//+------------------------------------------------------------------+

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 4            
#property indicator_color1 Red      
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Green

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

int width;

extern int Rperiod=15;
extern int LSMA_Period=5;
extern int Div = 3;
input int  history = 1000;

int Draw4HowLong;
int shift;
int i;
int j;
int loopbegin;
int length;
int lsma_length;

double lengthvar;
double tmp;
double tmp2;
double wt[];
double sum[];
double lsma_sum[];
double lsma_ma[];
double middle[];
int c;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//---- 7 additional buffers are used for counting.
   IndicatorBuffers(7);

//---- drawing settings

   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);

   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_NONE);

   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);

   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_NONE);


   SetIndexBuffer(4,sum);
   SetIndexBuffer(5,wt);
   SetIndexBuffer(6,lsma_ma);

//---- initialization done
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, const datetime &time[],
                const double &open[], const double &high[], const double &low[], const double &close[],
                const long &tick_volume[], const long &volume[], const int &spread[])
{
  
  int needForCount = rates_total - prev_calculated;         //  ,  0-  1-    
  if(prev_calculated == 0 )                                 // -    
  {
    needForCount = rates_total - 1;
    if(needForCount > history) needForCount = history-1;
  }
  
   Draw4HowLong=Bars-Rperiod-5;                            //Rperiod = 20
   length=Rperiod;                                           //length now = 20  
   lsma_length=LSMA_Period;
   loopbegin=Draw4HowLong-length-1;


   for(shift = needForCount; shift >= 0; --shift)
   {
      sum[1]=0;
      for(i=length; i>=1; i--) //LSMA loop
      {
         lengthvar=length+1;                               //lengthvar = 21  
         lengthvar/=Div;                                       //lengthvar = 7
         tmp =0;
         tmp=(i-lengthvar)*Close[length-i+shift];         //tmp = 20 - 7 * close[20-i+shift]
         sum[1]+=tmp;
      }
      wt[shift]=sum[1]*6/(length*(length+1));
      j=shift;
      lsma_ma[shift]=wt[j+1]+(wt[j]-wt[j+1]) *2/(lsma_length+1);

      //========== COLOR CODING ===========================================                       

      ExtMapBuffer1[shift] = (wt[shift]+lsma_ma[shift])/2;
      ExtMapBuffer2[shift] = lsma_ma[shift];
      ExtMapBuffer3[shift] = (wt[shift]+lsma_ma[shift])/2;
      ExtMapBuffer4[shift] = lsma_ma[shift];



      if(wt[shift]<lsma_ma[shift])
      {
         ExtMapBuffer4[shift] = EMPTY_VALUE;
         ExtMapBuffer3[shift] = EMPTY_VALUE;
      }

     }
     
  return(rates_total);
}
//+------------------------------------------------------------------+------+
